"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .syncsetting import SyncSetting, SyncSettingTypedDict
from codat_common.types import BaseModel
import pydantic
from typing import List, Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class UpdateProfileSyncSettingsRequestBodyTypedDict(TypedDict):
    r"""Include a `syncSetting` object for each data type.
    `syncFromWindow`, `syncFromUTC` & `monthsToSync` only need to be included if you wish to set a value for them.
    """

    client_id: str
    r"""Unique identifier for your client in Codat."""
    settings: List[SyncSettingTypedDict]
    overrides_defaults: NotRequired[bool]
    r"""Set to `True` if you want to override default [sync settings](https://docs.codat.io/knowledge-base/advanced-sync-settings)."""


class UpdateProfileSyncSettingsRequestBody(BaseModel):
    r"""Include a `syncSetting` object for each data type.
    `syncFromWindow`, `syncFromUTC` & `monthsToSync` only need to be included if you wish to set a value for them.
    """

    client_id: Annotated[str, pydantic.Field(alias="clientId")]
    r"""Unique identifier for your client in Codat."""

    settings: List[SyncSetting]

    overrides_defaults: Annotated[
        Optional[bool], pydantic.Field(alias="overridesDefaults")
    ] = True
    r"""Set to `True` if you want to override default [sync settings](https://docs.codat.io/knowledge-base/advanced-sync-settings)."""
